// Code generated by go-swagger; DO NOT EDIT.

package statistics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// StatisticsHandlerFunc turns a function with the right signature into a statistics handler
type StatisticsHandlerFunc func(StatisticsParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn StatisticsHandlerFunc) Handle(params StatisticsParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// StatisticsHandler interface for that can handle valid statistics params
type StatisticsHandler interface {
	Handle(StatisticsParams, *ticketboss) middleware.Responder
}

// NewStatistics creates a new http.Handler for the statistics operation
func NewStatistics(ctx *middleware.Context, handler StatisticsHandler) *Statistics {
	return &Statistics{Context: ctx, Handler: handler}
}

/*Statistics swagger:route GET /statistics Statistics statistics

Return current statistics.

Statistics on number of events, registrations, transaction cound and sum.

*/
type Statistics struct {
	Context *middleware.Context
	Handler StatisticsHandler
}

func (o *Statistics) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewStatisticsParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
